<?php
/**
 * This file is used to markup the admin license screen of the plugin.
 */
?>
<div class="kt-content-box">
	<h2><?php echo esc_html( __( 'Getting started with Klaviyo Toolkit', 'klaviyo-toolkit' ) ); ?></h2>
	<ol>
		<li><?php echo esc_html( __( 'Activate your license on the "License" tab.', 'klaviyo-toolkit' ) ); ?></li>
		<li><?php echo esc_html( __( 'Configure your Klaviyo public &amp; private API keys in the "Klaviyo API keys" tab.', 'klaviyo-toolkit' ) ); ?></li>
		<li><?php echo esc_html( __( 'Configure any metrics you’d like to start tracking on the "Settings" tab.', 'klaviyo-toolkit' ) ); ?></li>
		<li><?php echo esc_html( __( 'Once the events have triggered (ie. someone does something on your site to trigger the event), you’ll be able to view these new events under the “Dashboard > Activity Feed” section within Klaviyo. You can then create your flows and segments based off these new events.' ) ); ?></li>
	</ol>
	<p><?php echo esc_html( __( 'Note: These metrics can sometimes take time to populate. If you’ve configured everything correctly and are not seeing any metric data in Klaviyo after 24 hours, please contact us ', 'klaviyo-toolkit' ) ); ?><a href="<?php echo esc_url( 'https://www.madebytribe.com/contact-us/' ); ?>"><?php echo esc_html( __( 'here', 'klaviyo-toolkit' ) ); ?></a><?php echo esc_html( __( ' for help.', 'klaviyo-toolkit' ) ); ?></p>
	<hr>
	<h2><?php echo esc_html( __( 'Plugin documentation', 'klaviyo-toolkit' ) ); ?></h2>
	<ol>
		<li><a href="<?php echo esc_url( 'https://docs.madebytribe.com/topics/klaviyo-toolkit/metric-event-details/' ); ?>"><?php echo esc_html( __( 'Metric events', 'klaviyo-toolkit' ) ); ?></a></li>
		<li><a href="<?php echo esc_url( 'https://docs.madebytribe.com/topics/klaviyo-toolkit/generating-abandoned-cart-coupons/' ); ?>"><?php echo esc_html( __( 'Setting up abandoned checkout coupons for Klaviyo', 'klaviyo-toolkit' ) ); ?></a></li>
		<li><a href="<?php echo esc_url( 'https://docs.madebytribe.com/topics/klaviyo-toolkit/using-the-woocommerce-subscription-status-export-tool/' ); ?>"><?php echo esc_html( __( 'Importing subscription statuses into Klaviyo', 'klaviyo-toolkit' ) ); ?></a></li>
<li><a href="<?php echo esc_url( 'https://docs.madebytribe.com/topics/klaviyo-toolkit/' ); ?>"><?php echo esc_html( __( 'View all docs', 'klaviyo-toolkit' ) ); ?></a></li>
	</ol>
	<hr>
	<h2><?php echo esc_html( __( 'Requesting support', 'klaviyo-toolkit' ) ); ?></h2>
	<p><?php echo esc_html( __( 'If you need help with setting up the plugin or have questions please contact us ', 'klaviyo-toolkit' ) ); ?><a href="<?php echo esc_url( 'https://www.madebytribe.com/contact-us/' ); ?>"><?php echo esc_html( __( 'here', 'klaviyo-toolkit' ) ); ?></a><?php echo esc_html( __( '.', 'klaviyo-toolkit' ) ); ?></p>
	<hr>
	<h2><?php echo esc_html( __( 'Requesting a custom feature', 'klaviyo-toolkit' ) ); ?></h2>
	<p><?php echo esc_html( __( 'Need a feature not currently in our plugin? We do provide custom development services. Please fill out our feature request form ', 'klaviyo-toolkit' ) ); ?><a href="<?php echo esc_url( 'https://www.madebytribe.com/new-application/' ); ?>"><?php echo esc_html( __( 'here', 'klaviyo-toolkit' ) ); ?></a><?php echo esc_html( __( '.', 'klaviyo-toolkit' ) ); ?></p>
</div>