<?php

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}

$tribe_klaviyo_instance = new WCKT_Hooks();

// Trigger based on URL parameters
if (current_user_can('manage_options') && isset($_GET['export_wc_subscriptions']) && $_GET['export_wc_subscriptions'] == 'true') {
    $tribe_klaviyo_instance->show_export_progress();
}

if (current_user_can('manage_options') && isset($_GET['download_wc_subscriptions']) && $_GET['download_wc_subscriptions'] == 'true') {
    $tribe_klaviyo_instance->download_wc_subscriptions();
}
?>
<div class="kt-content-box">
    <h2><?php echo esc_html( __( 'Export WooCommerce Subscription Statuses (BETA)', 'klaviyo-toolkit' ) ); ?></h2>
    <p><?php echo esc_html( __( 'Export all of your WooCommerce Subscription statuses into a csv that can be imported into Klaviyo.', 'klaviyo-toolkit' ) ); ?></p>
    
    <p>
        <button class="button button-primary export-subscriptions-button" <?php echo esc_attr( $klaviyo_disabled_class ); ?>><?php echo esc_html( __( 'Run Export', 'klaviyo-toolkit' ) ); ?></button>
        <?php if ( 'valid' !== $klaviyo_edd_license_status ) { ?>
            <span class="klaviyo-pro-label"><?php echo esc_html( __( 'Get License', 'klaviyo-toolkit' ) ); ?></span>
        <?php } ?>
    </p>
    <div class="export-progress-container" style="display:none;">
        <strong class="export-notice"><?php echo esc_html( __( 'Please stay on this page until your download link has been generated.', 'klaviyo-toolkit' ) ); ?></strong>
        <div id="exportProgressBar" style="width: 100%; background-color: #ddd;">
            <div class="progress-meter">0%</div>
        </div>
    </div>
</div>


